// fileDownLoader.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"



#define BufferSize 16*1024

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}



bool doDownloadFile(HINTERNET hFile, HANDLE fileHandle,  DWORD length)
{
	DWORD bytesToRW = 0, bytesRW = 0;
	bool result = false;
	char* buffer;
	if ((buffer = (char*)malloc(BufferSize))!= NULL)
	{
		while (length > 0)
		{
			bytesToRW = __min(BufferSize, length);

			if (!InternetReadFile(hFile, buffer, bytesToRW, &bytesRW))
			{	
				break;
			}
			bytesToRW = bytesRW;
			if (WriteFile(fileHandle, buffer, bytesToRW, &bytesRW, NULL) && bytesRW == bytesToRW)
			{
				length -= bytesRW;
			}
			else
			{
				break;
			}
		}
		if (length == 0)
		{
			result = true;
		}
		free(buffer);
	}

	return result;
}


int __stdcall downloadFile(LPCTSTR url, LPCTSTR fileName)
{   
	HANDLE fileHandle = INVALID_HANDLE_VALUE;
	int result = 0;
	char lengthBuffer[32];
	DWORD length = 31;
	HINTERNET hSession ;
	HINTERNET hFile;


	if ((fileHandle = CreateFile(fileName, GENERIC_ALL, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
	{
		if ((hSession = InternetOpen(_T("Microsoft Internet Explorer"), INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, INTERNET_DEFAULT_HTTP_PORT))!= NULL)
		{
			if ((hFile = InternetOpenUrl(hSession, url, _T("Accept: */*") , 11, INTERNET_FLAG_RELOAD, NULL))!= NULL)
			{  			
				if (HttpQueryInfo(hFile, HTTP_QUERY_CONTENT_LENGTH , lengthBuffer, &length, 0))
				{
					lengthBuffer[length] = _T('\0');
					if (_stscanf((LPCTSTR)lengthBuffer, _T("%d"), &length) == 1)
					{					
						if (doDownloadFile(hFile, fileHandle, length))
						{
							result = length;
						}
					}
				}
				InternetCloseHandle(hFile);	
			}
			InternetCloseHandle(hSession);
		}
		CloseHandle(fileHandle);		
	}		
    return result;
}
